/**
 ****************************************************************************************************
 * @file        lcd.h
 * @author      ԭŶ(ALIENTEK)
 * @version     V1.0
 * @date        2023-07-20
 * @brief       2.8/3.5/4.3/7 TFTLCD(MCU) 
 *              ֧ICͺŰ:ILI9341/NT35310/NT35510/SSD1963/ST7789/ST7796/ILI9806
 *
 * @license     Copyright (c) 2020-2032, ӿƼ޹˾
 ****************************************************************************************************
 * @attention
 *
 * ʵƽ̨:ԭ CH32V307
 * Ƶ:www.yuanzige.com
 * ̳:www.openedv.com
 * ˾ַ:www.alientek.com
 * ַ:openedv.taobao.com
 *
 * ޸˵
 * V1.0 20230720
 * һη
 *
 ****************************************************************************************************
 */

#ifndef __LCD_H
#define __LCD_H

#include "stdlib.h"
#include "./SYSTEM/sys/sys.h"


/******************************************************************************************/

/* LCD WR/RD/BL/CS/RS  
 * LCD_D0~D15,̫,Ͳﶨ,ֱlcd_init޸.ֲʱ,˸
 * 6IO, øLCD_InitD0~D15ڵIO
 * RESET ϵͳλŹ ﲻö RESET */
#define LCD_WR_GPIO_PORT                GPIOD
#define LCD_WR_GPIO_PIN                 GPIO_Pin_5
#define LCD_WR_GPIO_CLK_ENABLE()        do{RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOD, ENABLE);}while(0) /* WRʱʹ */

#define LCD_RD_GPIO_PORT                GPIOD
#define LCD_RD_GPIO_PIN                 GPIO_Pin_4
#define LCD_RD_GPIO_CLK_ENABLE()        do{RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOD, ENABLE);}while(0) /* RDʱʹ */

#define LCD_BL_GPIO_PORT                GPIOB
#define LCD_BL_GPIO_PIN                 GPIO_Pin_4
#define LCD_BL_GPIO_CLK_ENABLE()        do{RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB, ENABLE);}while(0) /* ʱʹ */

/* LCD_CS(ҪLCD_FSMC_NEXȷIO) LCD_RS(ҪLCD_FSMC_AXȷIO)   */
#define LCD_CS_GPIO_PORT                GPIOD
#define LCD_CS_GPIO_PIN                 GPIO_Pin_7
#define LCD_CS_GPIO_CLK_ENABLE()        do{RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOD, ENABLE);}while(0) /* CSʱʹ */

#define LCD_RS_GPIO_PORT                GPIOE
#define LCD_RS_GPIO_PIN                 GPIO_Pin_3
#define LCD_RS_GPIO_CLK_ENABLE()        do{RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOD, ENABLE);}while(0) /* RSʱʹ */

/* FSMCز  
 * ע: ͨFSMC1LCD
 * ޸LCD_FSMC_AX , ӦLCD_RS_GPIOҲø
 */
#define LCD_FSMC_AX          19         /* ʹFSMC_A19LCD_RS */

/******************************************************************************************/

/* LCDҪ */
typedef struct
{
    uint16_t width;                 /* LCD  */
    uint16_t height;                /* LCD ߶ */
    uint16_t id;                    /* LCD ID */
    uint8_t dir;                    /* ƣ01 */
    uint16_t wramcmd;               /* ʼдgramָ */
    uint16_t setxcmd;               /* xָ */
    uint16_t setycmd;               /* yָ */
} _lcd_dev;

extern _lcd_dev lcddev;             /* LCDҪ */

/* LCDĻɫͱɫ */
extern uint32_t  g_point_color;     /* ĬϺɫ */
extern uint32_t  g_back_color;      /* ɫ.ĬΪɫ */

/* LCD */
#define LCD_BL(x)   do{ x ? \
                        GPIO_SetBits(LCD_BL_GPIO_PORT, LCD_BL_GPIO_PIN) : \
                        GPIO_ResetBits(LCD_BL_GPIO_PORT, LCD_BL_GPIO_PIN); \
                    }while(0)

/* LCDַṹ */
typedef struct
{
    volatile uint16_t LCD_REG;
    volatile uint16_t LCD_RAM;
} LCD_TypeDef;


/* LCD_BASEϸ㷽:
 * ʹFSMCĿ1(BLOCK1)TFTLCDҺ(MCU)
 * 洢1(FSMC_NE1)ַΧ: 0X6000 0000 ~ 0X60FF FFFF
 *
 * ʹFSMC_NE1LCD_CS, FSMC_A19LCD_RS, 16λ,㷽:
 * FSMC_NE1ĻַΪ: 0X6000 0000;
 * FSMC_A19Ӧֵַ: 2^19 * 2 = 0X100000; FSMC_AyӦĵַΪ(y = 16 ~ 23): 2^y * 2
 *
 * LCD->LCD_REG,ӦLCD_RS = 0(LCDĴ); LCD->LCD_RAM,ӦLCD_RS = 1(LCD)
 *  LCD->LCD_RAMĵַΪ:  0X6000 0000 + 2^19 * 2 = 0X60100000
 *    LCD->LCD_REGĵַΪ LCD->LCD_RAMַ֮.
 * ʹýṹLCD_REG  LCD_RAM(REGǰ,RAMں,Ϊ16λݿ)
 *  ṹĻַ(LCD_BASE) = LCD_RAM - 2 = 0X60100000 -2
 *
 * ͨõļ㹫ʽΪ(ƬѡFSMC_NE1,RSӵַFSMC_Ay,y=16~23):
 *          LCD_BASE = (0X6000 0000 | (2^y * 2 -2), Ч(ʹλ):
 *          LCD_BASE = (0X6000 0000 | ((1 << y) * 2 -2)
 */
#define LCD_BASE        (uint32_t)(0X60000000 | (((1 << LCD_FSMC_AX) * 2) -2))
#define LCD             ((LCD_TypeDef *) LCD_BASE)

/******************************************************************************************/
/* LCDɨ跽ɫ  */

/* ɨ跽 */
#define L2R_U2D         0           /* ,ϵ */
#define L2R_D2U         1           /* ,µ */
#define R2L_U2D         2           /* ҵ,ϵ */
#define R2L_D2U         3           /* ҵ,µ */

#define U2D_L2R         4           /* ϵ, */
#define U2D_R2L         5           /* ϵ,ҵ */
#define D2U_L2R         6           /* µ, */
#define D2U_R2L         7           /* µ,ҵ */

#define DFT_SCAN_DIR    L2R_U2D     /* Ĭϵɨ跽 */

/* ûɫ */
#define WHITE           0xFFFF      /* ɫ */
#define BLACK           0x0000      /* ɫ */
#define RED             0xF800      /* ɫ */
#define GREEN           0x07E0      /* ɫ */
#define BLUE            0x001F      /* ɫ */ 
#define MAGENTA         0XF81F      /* Ʒɫ/Ϻɫ = BLUE + RED */
#define YELLOW          0XFFE0      /* ɫ = GREEN + RED */
#define CYAN            0X07FF      /* ɫ = GREEN + BLUE */  

/* ǳɫ */
#define BROWN           0XBC40      /* ɫ */
#define BRRED           0XFC07      /* غɫ */
#define GRAY            0X8430      /* ɫ */ 
#define DARKBLUE        0X01CF      /* ɫ */
#define LIGHTBLUE       0X7D7C      /* ǳɫ */ 
#define GRAYBLUE        0X5458      /* ɫ */ 
#define LIGHTGREEN      0X841F      /* ǳɫ */  
#define LGRAY           0XC618      /* ǳɫ(PANNEL),屳ɫ */ 
#define LGRAYBLUE       0XA651      /* ǳɫ(мɫ) */ 
#define LBBLUE          0X2B12      /* ǳɫ(ѡĿķɫ) */ 

/******************************************************************************************/
/* SSD1963ò(һ㲻ø) */

/* LCDֱ */ 
#define SSD_HOR_RESOLUTION      800     /* LCDˮƽֱ */ 
#define SSD_VER_RESOLUTION      480     /* LCDֱֱ */ 

/* LCD */ 
#define SSD_HOR_PULSE_WIDTH     1       /* ˮƽ */ 
#define SSD_HOR_BACK_PORCH      46      /* ˮƽǰ */ 
#define SSD_HOR_FRONT_PORCH     210     /* ˮƽ */ 

#define SSD_VER_PULSE_WIDTH     1       /* ֱ */ 
#define SSD_VER_BACK_PORCH      23      /* ֱǰ */ 
#define SSD_VER_FRONT_PORCH     22      /* ֱǰ */ 

/* ¼Զ */ 
#define SSD_HT          (SSD_HOR_RESOLUTION + SSD_HOR_BACK_PORCH + SSD_HOR_FRONT_PORCH)
#define SSD_HPS         (SSD_HOR_BACK_PORCH)
#define SSD_VT          (SSD_VER_RESOLUTION + SSD_VER_BACK_PORCH + SSD_VER_FRONT_PORCH)
#define SSD_VPS         (SSD_VER_BACK_PORCH)
   
/******************************************************************************************/

void lcd_wr_data(volatile uint16_t data);            /* LCDд */
void lcd_wr_regno(volatile uint16_t regno);          /* LCDдĴ/ַ */
void lcd_write_reg(uint16_t regno, uint16_t data);   /* LCDдĴֵ */

void lcd_init(void);                                 /* ʼLCD */
void lcd_display_on(void);                           /* ʾ */
void lcd_display_off(void);                          /* ʾ */
void lcd_scan_dir(uint8_t dir);                      /* ɨ跽 */
void lcd_display_dir(uint8_t dir);                   /* Ļʾ */
void lcd_ssd_backlight_set(uint8_t pwm);             /* SSD1963  */

void lcd_write_ram_prepare(void);                           /* ׼дGRAM */
void lcd_set_cursor(uint16_t x, uint16_t y);                /* ù */
uint32_t lcd_read_point(uint16_t x, uint16_t y);            /* (32λɫ,LTDC) */
void lcd_draw_point(uint16_t x, uint16_t y, uint32_t color);/* (32λɫ,LTDC) */

void lcd_clear(uint16_t color);                                                             /* LCD */
void lcd_fill_circle(uint16_t x, uint16_t y, uint16_t r, uint16_t color);                   /* ʵԲ */
void lcd_draw_circle(uint16_t x0, uint16_t y0, uint8_t r, uint16_t color);                  /* Բ */
void lcd_draw_hline(uint16_t x, uint16_t y, uint16_t len, uint16_t color);                  /* ˮƽ */
void lcd_set_window(uint16_t sx, uint16_t sy, uint16_t width, uint16_t height);             /* ô */
void lcd_fill(uint16_t sx, uint16_t sy, uint16_t ex, uint16_t ey, uint32_t color);          /* ɫ(32λɫ,LTDC)*/
void lcd_color_fill(uint16_t sx, uint16_t sy, uint16_t ex, uint16_t ey, uint16_t *color);   /* ɫ */
void lcd_draw_line(uint16_t x1, uint16_t y1, uint16_t x2, uint16_t y2, uint16_t color);     /* ֱ */
void lcd_draw_rectangle(uint16_t x1, uint16_t y1, uint16_t x2, uint16_t y2, uint16_t color);/*  */

void lcd_show_char(uint16_t x, uint16_t y, char chr, uint8_t size, uint8_t mode, uint16_t color);                     /* ʾһַ */
void lcd_show_num(uint16_t x, uint16_t y, uint32_t num, uint8_t len, uint8_t size, uint16_t color);                   /* ʾ */
void lcd_show_xnum(uint16_t x, uint16_t y, uint32_t num, uint8_t len, uint8_t size, uint8_t mode, uint16_t color);    /* չʾ */
void lcd_show_string(uint16_t x, uint16_t y, uint16_t width, uint16_t height, uint8_t size, char *p, uint16_t color); /* ʾַ */

#endif

