/**
 ****************************************************************************************************
 * @file        delay.c
 * @author      ԭŶ(ALIENTEK)
 * @version     V1.0
 * @date        2023-07-20
 * @brief       ṩdelay_initʼ delay_usdelay_msʱ
 * @license     Copyright (c) 2020-2032, ӿƼ޹˾
 ****************************************************************************************************
 * @attention
 *
 * ʵƽ̨:ԭ CH32V307
 * Ƶ:www.yuanzige.com
 * ̳:www.openedv.com/forum.php
 * ˾ַ:www.alientek.com
 * ַ:zhengdianyuanzi.tmall.com
 *
 * ޸˵
 * V1.0 20230720
 * һη
 *
 ****************************************************************************************************
 */

#include "./SYSTEM/delay/delay.h"


static uint16_t g_fac_us = 0;      /* usʱ */

/**
 * @brief       ʼӳٺ
 * @param       sysclk: ϵͳʱƵ,CPUƵ(HCLK),MHzΪλ
 * @retval      
 */
void delay_init(uint16_t sysclk)
{
    g_fac_us = sysclk / 8;
}

/**
 * @brief       ʱnus
 * @param       nus: Ҫʱus
 * @retval      
 */
void delay_us(uint32_t nus)
{
    uint32_t temp;

    SysTick->CTLR = (1<<4);                  /* ¼ */
    temp = (uint32_t)nus * g_fac_us;         /* Ƚֵ */

    SysTick->CMP = temp;                     /* ñȽֵ */
    SysTick->CTLR |= (1<<5)|(1<<0);          /* ±Ƚֵ */

    while((SysTick->SR & (1<<0)) != (1<<0)); /* ȴ */
    SysTick->SR &= ~(1<<0);                  /* ־ */
}

/**
 * @brief       ʱnms
 * @param       nms: Ҫʱms (0< nms <= 65535)
 * @retval      
 */
void delay_ms(uint16_t nms)
{
    uint32_t repeat = nms / 1000;
    uint32_t remain = nms % 1000;

    while (repeat)
    {
        delay_us(1000 * 1000);      /* delay_usʵ1000msʱ */
        repeat--;
    }

    if (remain)
    {
        delay_us(remain * 1000);    /* delay_us,βʱ(remain ms) */
    }
}
