/**
 ****************************************************************************************************
 * @file        main.c
 * @author      ԭŶ(ALIENTEK)
 * @version     V1.0
 * @date        2023-07-20
 * @brief       FLASHģEEPROM ʵ
 * @license     Copyright (c) 2020-2032, ӿƼ޹˾
 ****************************************************************************************************
 * @attention
 *
 * ʵƽ̨:ԭ CH32V307
 * Ƶ:www.yuanzige.com
 * ̳:www.openedv.com/forum.php
 * ˾ַ:www.alientek.com
 * ַ:zhengdianyuanzi.tmall.com
 *
 ****************************************************************************************************
 */

#include "./SYSTEM/sys/sys.h"
#include "./SYSTEM/delay/delay.h"
#include "./SYSTEM/usart/usart.h"
#include "./BSP/LED/led.h"
#include "./BSP/LCD/lcd.h"
#include "./BSP/KEY/key.h"
#include "./BSP/CHFLASH/chflash.h"


/* Ҫд뵽CH32 FLASHַ */
const uint8_t g_text_buf[] = {"CH32 FLASH TEST"};

#define TEXT_LENTH sizeof(g_text_buf) /* 鳤 */

/* SIZEʾֳ(2ֽ), С2, ǵĻ, ǿƶ뵽2 */
#define SIZE TEXT_LENTH / 2 + ((TEXT_LENTH % 2) ? 1 : 0)

#define FLASH_SAVE_ADDR 0X08010000 /* FLASH ַ(ΪżֵҪڱռFLASHĴС + 0X08000000) */

int main(void)
{
    uint8_t key = 0;
    uint16_t i = 0;
    uint8_t datatemp[SIZE];

    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);     /* жȼ2 */
    delay_init(144);                                    /* ʱʼ */
    usart_init(115200);                                 /* ڳʼΪ115200 */
    led_init();                                         /* ʼLED */
    lcd_init();                                         /* ʼLCD */
    key_init();                                         /* ʼ */

    lcd_show_string(30,  50, 200, 16, 16, "CH32", RED);
    lcd_show_string(30,  70, 200, 16, 16, "FLASH EEPROM TEST", RED);
    lcd_show_string(30,  90, 200, 16, 16, "ATOM@ALIENTEK", RED);
    lcd_show_string(30, 110, 200, 16, 16, "KEY1:Write  KEY0:Read", RED);

    while (1)
    {
        key = key_scan(0);

        if (key == KEY1_PRES)   /* KEY1,дCH32 FLASH */
        {
            lcd_fill(0, 150, 239, 319, WHITE);                                   /*  */
            lcd_show_string(30, 150, 200, 16, 16, "Start Write FLASH....", RED);
            chflash_write(FLASH_SAVE_ADDR, (uint16_t*)g_text_buf, SIZE);
            lcd_show_string(30, 150, 200, 16, 16, "FLASH Write Finished!", RED); /* ʾ */
        }

        if (key == KEY0_PRES)   /* KEY0,ȡַʾ */
        {
            lcd_show_string(30, 150, 200, 16, 16, "Start Read FLASH.... ", RED);
            chflash_read(FLASH_SAVE_ADDR, (uint16_t*)datatemp, SIZE);
            lcd_show_string(30, 150, 200, 16, 16, "The Data Readed Is:  ", RED); /* ʾ */
            lcd_show_string(30, 170, 200, 16, 16, (char*)datatemp, BLUE);        /* ʾַ */
        }

        i++;
        delay_ms(10);

        if (i == 20)
        {
            LED0_TOGGLE();      /* ʾϵͳ */
            i = 0;
        }
    }
}

